/*
 File: link_cleansersym.cpp
 Date and Time: Fri Jan 30 18:55:14 2015 
*/
#include "link_cleanser.h"
using namespace NS_yacco2_T_enum;// enumerate
using namespace NS_yacco2_err_symbols;// error symbols
using namespace NS_yacco2_k_symbols;// lrk 
using namespace NS_yacco2_terminals;// terminals
using namespace NS_yacco2_characters;// rc 
using namespace yacco2;// yacco2 library
using namespace NS_link_cleanser;// grammar's ns
// first set terminals
// monolithic grammar --- no thread
void 
Clink_cleanser::reduce_rhs_of_rule
    (yacco2::UINT Sub_rule_no,yacco2::Rule_s_reuse_entry** Recycled_rule){
   int reducing_rule = rhs_to_rules_mapping_[Sub_rule_no];
   Per_rule_s_reuse_table* rule_reuse_tbl_ptr = 
        fsm_rules_reuse_table.per_rule_s_table_[reducing_rule];
   Rule_s_reuse_entry* re(0);
   find_a_recycled_rule(rule_reuse_tbl_ptr,&re);
   (*Recycled_rule) = re;
   fnd_re: switch (Sub_rule_no){
    case rhs1_Rpass3_:{
       Rpass3* sym;
     if(re->rule_ == 0){
       sym = new Rpass3(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rpass3*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 1;
    

     sym->op();
     return;}
    case rhs2_Rpass3_:{
       Rpass3* sym;
     if(re->rule_ == 0){
       sym = new Rpass3(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rpass3*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->op();
     return;}
    case rhs1_Relems_:{
       Relems* sym;
     if(re->rule_ == 0){
       sym = new Relems(parser__);
       re->rule_ = sym;
     }else{
       sym = (Relems*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 1;
    

     return;}
    case rhs2_Relems_:{
       Relems* sym;
     if(re->rule_ == 0){
       sym = new Relems(parser__);
       re->rule_ = sym;
     }else{
       sym = (Relems*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     return;}
    case rhs1_Rtoken_:{
       Rtoken* sym;
     if(re->rule_ == 0){
       sym = new Rtoken(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rtoken*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     return;}
    case rhs2_Rtoken_:{
       Rtoken* sym;
     if(re->rule_ == 0){
       sym = new Rtoken(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rtoken*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr2();
     return;}
    case rhs3_Rtoken_:{
       Rtoken* sym;
     if(re->rule_ == 0){
       sym = new Rtoken(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rtoken*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr3();
     return;}
    case rhs4_Rtoken_:{
       Rtoken* sym;
     if(re->rule_ == 0){
       sym = new Rtoken(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rtoken*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 1;
    

     sym->sr4();
     return;}
    case rhs5_Rtoken_:{
       Rtoken* sym;
     if(re->rule_ == 0){
       sym = new Rtoken(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rtoken*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr5();
     return;}
    case rhs6_Rtoken_:{
       Rtoken* sym;
     if(re->rule_ == 0){
       sym = new Rtoken(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rtoken*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr6();
     return;}
    case rhs7_Rtoken_:{
       Rtoken* sym;
     if(re->rule_ == 0){
       sym = new Rtoken(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rtoken*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr7();
     return;}
    case rhs8_Rtoken_:{
       Rtoken* sym;
     if(re->rule_ == 0){
       sym = new Rtoken(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rtoken*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr8();
     return;}
    case rhs9_Rtoken_:{
       Rtoken* sym;
     if(re->rule_ == 0){
       sym = new Rtoken(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rtoken*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr9();
     return;}
    case rhs10_Rtoken_:{
       Rtoken* sym;
     if(re->rule_ == 0){
       sym = new Rtoken(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rtoken*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     return;}
    case rhs11_Rtoken_:{
       Rtoken* sym;
     if(re->rule_ == 0){
       sym = new Rtoken(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rtoken*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr11();
     return;}
    case rhs12_Rtoken_:{
       Rtoken* sym;
     if(re->rule_ == 0){
       sym = new Rtoken(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rtoken*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr12();
     return;}
    case rhs13_Rtoken_:{
       Rtoken* sym;
     if(re->rule_ == 0){
       sym = new Rtoken(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rtoken*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr13();
     return;}
    case rhs14_Rtoken_:{
       Rtoken* sym;
     if(re->rule_ == 0){
       sym = new Rtoken(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rtoken*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr14();
     return;}
    case rhs15_Rtoken_:{
       Rtoken* sym;
     if(re->rule_ == 0){
       sym = new Rtoken(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rtoken*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr15();
     return;}
    default: return;
   }
}
